package.path = [[.\lua_lib\?.lua;]] .. package.path
package.cpath = [[.\lua_lib\?.dll;]] .. package.cpath
local 字集码互转库 = require("u8_to_a")
local u8 = 字集码互转库.u8_to_a
local f = require(u8("常用库"))
local 字段名对 = require(u8("字段名"))
local 简文件库 = require("lfs")
local 简数据库库 = require("lsqlite3")
local d = {}
do
  local TYPE_SPELL = 0x2
  local TYPE_TRAP = 0x4
  local TYPE_EFFECT = 0x20
  local TYPE_PENDULUM = 0x1000000
  local 有效果卡的类排 = {
  TYPE_SPELL
  , TYPE_TRAP
  , TYPE_EFFECT
  }
  local 无效果灵摆怪兽排 = {
    28363749 --火蛋白石头龙头领
    , 19474136 --曼陀林草龙
    , 17390179 --闪光之骑士
    , 83980492 --铜锣龙
    }
  --~ 卡对
  function d.筛有效果卡(o1_4)
    for o1 = 1, #有效果卡的类排 do
      if bit.band(有效果卡的类排[o1], o1_4.type) == 0 then
      else
        return o1_4
        end
      end
    if bit.band(TYPE_PENDULUM, o1_4.type) == 0 then
    else
      if 无效果灵摆怪兽排[o1_4.id] then
      else
        return o1_4
        end
      end
    end
  end
--~ 各文件的卡对排
function d.筛有效果卡_一维(o1_0)
  return f.历排(o1_0, d.筛有效果卡)
  end
--~ 各文件的卡编排
function d.取卡对_一维(o1_0)
  return f.历排(o1_0, d.取卡对)
  end
--~ 卡编
function d.取卡对(o1)
  local k1_0, k2_0
  --~ 卡文对
  k1_0 = d.取卡文(o1)
  --~ 卡数据对
  k2_0 = d.取卡数据(o1)
  return f.连两对(k1_0, k2_0)
  end
--~ 卡编
function d.取卡文(o1)
  for o1_4 in 数据库:nrows("select * from texts where id = " .. o1) do
    return o1_4
    end
  end
--~ 卡编
function d.取卡数据(o1)
  for o1_4 in 数据库:nrows("select * from datas where id = " .. o1) do
    return o1_4
    end
  end
--~ 文
function d.局筛卡编(o1)
  local k1_0
  --~ 卡编排
  k1_0 = f.历文(o1, string.gmatch, "[^\n]+")
  k1_0 = f.历排(k1_0, string.match, "Debug%.AddCard.+")
  return f.历排(k1_0, string.match, "[0-9]+")
  end
--~ 文
function d.局筛则数(o1)
  local k1
  local k1_0
  --~ 则数排
  k1_0 = f.历文(o1, string.gmatch, "[^\n]+")
  k1_0 = f.历排(k1_0, f.全筛前缀, "Debug.ReloadFieldBegin")
  --~ 则数
  k1 = string.match(k1_0[1], "[0-9]")
  return k1 or 3
  end
--~ 卡对排
function d.荐名(o1_0)
  local k1
  --~ 名
  k1 = d.荐字段名(o1_0)
  if k1 then
  else
    k1 = d.荐卡名(o1_0)
    end
  if k1 then
    return k1
  else
    return "请便"
    end
  end
function d.荐卡名(o1_0)
  local k1_0
  --~ 卡名排
  k1_0 = d.取卡名排(o1_0)
  return f.历排取一(k1_0, f.筛排中最短文)
  end
--~ 卡对排
function d.取卡名排(o1_0)
  local k1_0
  --~ 卡名排
  k1_0 = {}
  for o1 = 1, #o1_0 do
    k1_0[o1] = o1_0[o1].name
    end
  return k1_0
  end
--~ 卡对排
function d.取字段对(o1_0)
  local k1, k2, k3, k4
  local k1_0
  --~ 字段对
  k1_0 = {}
  for o1 = 1, #o1_0 do
    --~ 字段数
    k1 = f.to_uint64(o1_0[o1].setcode)
    if k1 > 0xffffFFFFffff then
      k1 = k1 - 1
    elseif k1 < 1 then
    else
      for o2 = 1, 11112222 do
        if k1 < 1 then
          break
        else
          --~ 大字段号
          k2 = f.位和(k1, 0xffff)
          k1 = f.位右移(k1, f.乘法(4, 4))
          --~ 字段名
          k3 = 字段名对[tonumber(k2)]
          if k3 then
            if k1_0[k3] then
              k1_0[k3] = f.加法(k1_0[k3], 1)
            else
              k1_0[k3] = 1
              end
            if k2 > 0xfff then
              --~ 小字段号
              k4 = f.位和(k2, 0xfff)
              k3 = 字段名对[tonumber(k4)]
              if k3 then
                if k1_0[k3] then
                  k1_0[k3] = f.加法(k1_0[k3], 1)
                else
                  k1_0[k3] = 1
                  end
              else
                end
            else
              end
          else
            end
          end
        end
      end
    end
  return k1_0
  end
--~ 卡对排
function d.荐字段名(o1_0)
  local k1
  local k1_0
  --~ 字段对
  k1_0 = d.取字段对(o1_0)
  --~ 最大的字段名数量
  _, k1 = f.历对取一(k1_0, f.筛对中最大值)
  --~ 最高频字段名对
  k2_0 = f.历对(k1_0, f.全等筛对中值, k1)
  return f.历对取一(k2_0, f.筛对中最短键)
  end
--~ 目对
function d.残局荐名(o1_0)
  local k1_0, k2_0, k3_0, k4_0, k5_0, k6_0, k7_0, k8_0
  --~ 文件名排
  k1_0 = f.历文(o1_0.文件目, 简文件库.dir)
  k1_0 = f.历排(k1_0, f.全筛后缀, ".lua")
  --~ 文件排
  k2_0 = f.历排(k1_0, f.全筛后缀, ".lua")
  for o1 = 1, #k2_0 do
    k2_0[o1] = f.加前缀(k2_0[o1], o1_0.文件目)
    k2_0[o1] = f.读文件(k2_0[o1])
    k2_0[o1] = string.gsub(k2_0[o1], "%-%-" .. "%[(=*)%[" .. ".-" .. "%]%1%]", "")
    k2_0[o1] = string.gsub(k2_0[o1], "%-%-" .. "[^\n]*", "")
    end
  --~ 则数排
  k3_0 = f.历排(k2_0, d.局筛则数)
  --~ 各文件的卡编排
  k4_0 = f.历排(k2_0, d.局筛卡编)
  _G.数据库 = 简数据库库.open(o1_0.数据库路)
  --~ 各文件的卡对排
  k5_0 = f.历排(k4_0, d.取卡对_一维)
  --~ 有效果卡的卡对排
  k6_0 = f.历排(k5_0, d.筛有效果卡_一维)
  --~ 有效果卡的张数排
  k7_0 = f.历排(k6_0, table.maxn)
  --~ 荐名排
  k8_0 = f.历排(k6_0, d.荐名)
  for o1 = 1, #k1_0 do
    print(字集码互转库.a_to_u8(k1_0[o1]), k3_0[o1], k7_0[o1], k8_0[o1])
    end
  end
d.目对 = {
  ["文件目"] = "../single/"
  , ["数据库路"] = [[D:\install\YGOPro\cards.cdb]]
  }
for o1, o2 in pairs(d.目对) do
  d.目对[o1] = f.操类(o2, "string", u8)
  end
d.残局荐名(d.目对)
